/* RequirementParser.c generated by valac 0.36.2, the Vala compiler
 * generated from RequirementParser.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_REQUIREMENT_PARSER (drt_requirement_parser_get_type ())
#define DRT_REQUIREMENT_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_REQUIREMENT_PARSER, DrtRequirementParser))
#define DRT_REQUIREMENT_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_REQUIREMENT_PARSER, DrtRequirementParserClass))
#define DRT_IS_REQUIREMENT_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_REQUIREMENT_PARSER))
#define DRT_IS_REQUIREMENT_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_REQUIREMENT_PARSER))
#define DRT_REQUIREMENT_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_REQUIREMENT_PARSER, DrtRequirementParserClass))

typedef struct _DrtRequirementParser DrtRequirementParser;
typedef struct _DrtRequirementParserClass DrtRequirementParserClass;
typedef struct _DrtRequirementParserPrivate DrtRequirementParserPrivate;

#define DRT_REQUIREMENT_PARSER_TYPE_TOKS (drt_requirement_parser_toks_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
typedef struct _DrtParamSpecRequirementParser DrtParamSpecRequirementParser;

typedef enum  {
	DRT_REQUIREMENT_ERROR_PARSE,
	DRT_REQUIREMENT_ERROR_SYNTAX,
	DRT_REQUIREMENT_ERROR_EVAL
} DrtRequirementError;
#define DRT_REQUIREMENT_ERROR drt_requirement_error_quark ()
struct _DrtRequirementParser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtRequirementParserPrivate * priv;
};

struct _DrtRequirementParserClass {
	GTypeClass parent_class;
	void (*finalize) (DrtRequirementParser *self);
	gboolean (*call) (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params);
	void (*reset) (DrtRequirementParser* self);
};

struct _DrtRequirementParserPrivate {
	gchar* _data;
	gint _pos;
	gint _error_pos;
	gchar* _error_text;
	GError* error_object;
	gint len;
	GRegex* patterns;
	gint peeked_token_len;
};

typedef enum  {
	DRT_REQUIREMENT_PARSER_TOKS_NONE,
	DRT_REQUIREMENT_PARSER_TOKS_SPACE,
	DRT_REQUIREMENT_PARSER_TOKS_SEMICOLON,
	DRT_REQUIREMENT_PARSER_TOKS_IDENT,
	DRT_REQUIREMENT_PARSER_TOKS_PARAMS,
	DRT_REQUIREMENT_PARSER_TOKS_EOF
} DrtRequirementParserToks;

struct _DrtParamSpecRequirementParser {
	GParamSpec parent_instance;
};


static gpointer drt_requirement_parser_parent_class = NULL;

GQuark drt_requirement_error_quark (void);
gpointer drt_requirement_parser_ref (gpointer instance);
void drt_requirement_parser_unref (gpointer instance);
GParamSpec* drt_param_spec_requirement_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_requirement_parser (GValue* value, gpointer v_object);
void drt_value_take_requirement_parser (GValue* value, gpointer v_object);
gpointer drt_value_get_requirement_parser (const GValue* value);
GType drt_requirement_parser_get_type (void) G_GNUC_CONST;
#define DRT_REQUIREMENT_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_REQUIREMENT_PARSER, DrtRequirementParserPrivate))
enum  {
	DRT_REQUIREMENT_PARSER_DUMMY_PROPERTY
};
static GType drt_requirement_parser_toks_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* drt_requirement_parser_toks_to_str (DrtRequirementParserToks self);
const gchar* drt_requirement_parser_toks_to_string (DrtRequirementParserToks self);
DrtRequirementParser* drt_requirement_parser_new (void);
DrtRequirementParser* drt_requirement_parser_construct (GType object_type);
static void drt_requirement_parser_set_pos (DrtRequirementParser* self, gint value);
static void drt_requirement_parser_set_data (DrtRequirementParser* self, const gchar* value);
static void drt_requirement_parser_set_error_text (DrtRequirementParser* self, const gchar* value);
static void drt_requirement_parser_set_error_pos (DrtRequirementParser* self, gint value);
gchar* drt_requirement_parser_mark_pos (DrtRequirementParser* self, gint start, gint len);
const gchar* drt_requirement_parser_get_data (DrtRequirementParser* self);
gint drt_requirement_parser_get_pos (DrtRequirementParser* self);
gboolean drt_requirement_parser_eval (DrtRequirementParser* self, const gchar* requirements, gchar* * failed_requirements, GError** error);
void drt_requirement_parser_reset (DrtRequirementParser* self);
static gboolean drt_requirement_parser_parse_all (DrtRequirementParser* self, gchar* * failed_requirements);
gboolean drt_requirement_parser_is_error_set (DrtRequirementParser* self);
gint drt_requirement_parser_get_error_pos (DrtRequirementParser* self);
gboolean drt_requirement_parser_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params);
static gboolean drt_requirement_parser_real_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params);
gboolean drt_requirement_parser_set_eval_error (DrtRequirementParser* self, gint pos, const gchar* text, ...);
static void drt_requirement_parser_real_reset (DrtRequirementParser* self);
gboolean drt_requirement_parser_set_parse_error (DrtRequirementParser* self, gint pos, const gchar* text, ...);
static void drt_requirement_parser_set_error (DrtRequirementParser* self, GError* err, gint pos, const gchar* text);
gboolean drt_requirement_parser_set_syntax_error (DrtRequirementParser* self, gint pos, const gchar* text, ...);
static gboolean drt_requirement_parser_wrong_token (DrtRequirementParser* self, gint pos, DrtRequirementParserToks found, const gchar* expected);
static gboolean drt_requirement_parser_next (DrtRequirementParser* self, DrtRequirementParserToks* tok, gchar* * val, gint* position);
static gboolean drt_requirement_parser_peek (DrtRequirementParser* self, DrtRequirementParserToks* tok, gchar* * val, gint* position);
static gboolean drt_requirement_parser_skip (DrtRequirementParser* self);
static gboolean drt_requirement_parser_parse_rule (DrtRequirementParser* self, gint pos, const gchar* ident, gchar* * failed_requirements);
static gboolean drt_requirement_parser_parse_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params, gchar* * failed_requirements);
const gchar* drt_requirement_parser_get_error_text (DrtRequirementParser* self);
static void drt_requirement_parser_finalize (DrtRequirementParser * obj);


GQuark drt_requirement_error_quark (void) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	return g_quark_from_static_string ("drt_requirement_error-quark");
#line 151 "RequirementParser.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1295 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1295 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1295 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1295 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1296 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1296 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 174 "RequirementParser.c"
		glong _tmp4_;
#line 1297 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1297 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1297 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		return result;
#line 182 "RequirementParser.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1299 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1299 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1299 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1299 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		return result;
#line 194 "RequirementParser.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1306 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 218 "RequirementParser.c"
		glong _tmp2_;
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 224 "RequirementParser.c"
	} else {
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 228 "RequirementParser.c"
	}
#line 1308 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 232 "RequirementParser.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1310 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1310 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1310 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1310 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 244 "RequirementParser.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1312 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1312 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1312 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 254 "RequirementParser.c"
	}
#line 1315 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1315 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 260 "RequirementParser.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1316 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1316 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1316 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1317 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1317 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 274 "RequirementParser.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1319 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1319 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1319 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 284 "RequirementParser.c"
	}
#line 1321 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1321 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 290 "RequirementParser.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1322 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1322 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1322 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 299 "RequirementParser.c"
	}
#line 1324 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1324 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1324 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1324 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1325 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1325 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1325 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1325 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1325 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	return result;
#line 319 "RequirementParser.c"
}


static gchar* drt_requirement_parser_toks_to_str (DrtRequirementParserToks self) {
	gchar* result = NULL;
	GEnumValue* _tmp0_;
	GEnumValue* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = g_enum_get_value (g_type_class_ref (DRT_REQUIREMENT_PARSER_TYPE_TOKS), self);
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (DRT_REQUIREMENT_PARSER_TYPE_TOKS), DRT_REQUIREMENT_PARSER_TOKS_NONE);
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp2_ = strlen ((_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = _tmp2_;
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp4_ = string_substring ((_tmp0_ != NULL) ? _tmp0_->value_name : NULL, (glong) (_tmp3_ - 4), (glong) -1);
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp4_;
#line 379 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 344 "RequirementParser.c"
}


static GType drt_requirement_parser_toks_get_type (void) {
	static volatile gsize drt_requirement_parser_toks_type_id__volatile = 0;
	if (g_once_init_enter (&drt_requirement_parser_toks_type_id__volatile)) {
		static const GEnumValue values[] = {{DRT_REQUIREMENT_PARSER_TOKS_NONE, "DRT_REQUIREMENT_PARSER_TOKS_NONE", "none"}, {DRT_REQUIREMENT_PARSER_TOKS_SPACE, "DRT_REQUIREMENT_PARSER_TOKS_SPACE", "space"}, {DRT_REQUIREMENT_PARSER_TOKS_SEMICOLON, "DRT_REQUIREMENT_PARSER_TOKS_SEMICOLON", "semicolon"}, {DRT_REQUIREMENT_PARSER_TOKS_IDENT, "DRT_REQUIREMENT_PARSER_TOKS_IDENT", "ident"}, {DRT_REQUIREMENT_PARSER_TOKS_PARAMS, "DRT_REQUIREMENT_PARSER_TOKS_PARAMS", "params"}, {DRT_REQUIREMENT_PARSER_TOKS_EOF, "DRT_REQUIREMENT_PARSER_TOKS_EOF", "eof"}, {0, NULL, NULL}};
		GType drt_requirement_parser_toks_type_id;
		drt_requirement_parser_toks_type_id = g_enum_register_static ("DrtRequirementParserToks", values);
		g_once_init_leave (&drt_requirement_parser_toks_type_id__volatile, drt_requirement_parser_toks_type_id);
	}
	return drt_requirement_parser_toks_type_id__volatile;
}


/**
     * Creates new requirements parser and evaluator.
     * It can be reused for more calls of {@link eval}. 
     */
DrtRequirementParser* drt_requirement_parser_construct (GType object_type) {
	DrtRequirementParser* self = NULL;
	GError * _inner_error_ = NULL;
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self = (DrtRequirementParser*) g_type_create_instance (object_type);
#line 67 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->peeked_token_len = -1;
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->len = 0;
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_pos (self, 0);
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_data (self, NULL);
#line 71 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_text (self, NULL);
#line 72 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_pos (self, -1);
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_error_free0 (self->priv->error_object);
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->error_object = NULL;
#line 385 "RequirementParser.c"
	{
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = g_regex_new ("(\\s+)|(;)|(\\w+)|(\\[.*?\\])", 0, 0, &_inner_error_);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp0_ = _tmp1_;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 398 "RequirementParser.c"
				goto __catch49_g_regex_error;
			}
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_clear_error (&_inner_error_);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return NULL;
#line 407 "RequirementParser.c"
		}
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp2_ = _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp0_ = NULL;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_regex_unref0 (self->priv->patterns);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		self->priv->patterns = _tmp2_;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_regex_unref0 (_tmp0_);
#line 419 "RequirementParser.c"
	}
	goto __finally49;
	__catch49_g_regex_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		e = _inner_error_;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_inner_error_ = NULL;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp3_ = e->message;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_error ("RequirementParser.vala:80: Failed to compile regex patterns. %s", _tmp3_);
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_error_free0 (e);
#line 436 "RequirementParser.c"
	}
	__finally49:
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return NULL;
#line 447 "RequirementParser.c"
	}
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return self;
#line 451 "RequirementParser.c"
}


DrtRequirementParser* drt_requirement_parser_new (void) {
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return drt_requirement_parser_construct (DRT_TYPE_REQUIREMENT_PARSER);
#line 458 "RequirementParser.c"
}


/**
     * Print the parser expression with the given position marked.
     * 
     * @param pos    The position to mark.
     * @param len    The size of the mark.
     * @return marked string 
     */
gchar* drt_requirement_parser_mark_pos (DrtRequirementParser* self, gint start, gint len) {
	gchar* result = NULL;
	GString* buf;
	const gchar* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	GString* _tmp8_;
	GString* _tmp12_;
	GString* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_data;
#line 93 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = g_string_new (_tmp0_);
#line 93 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	buf = _tmp1_;
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp2_ = buf;
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_string_append_c (_tmp2_, '\n');
#line 492 "RequirementParser.c"
	{
		gint i;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		i = 0;
#line 497 "RequirementParser.c"
		{
			gboolean _tmp3_;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp3_ = TRUE;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			while (TRUE) {
#line 504 "RequirementParser.c"
				gint _tmp5_;
				gint _tmp6_;
				GString* _tmp7_;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				if (!_tmp3_) {
#line 510 "RequirementParser.c"
					gint _tmp4_;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					_tmp4_ = i;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					i = _tmp4_ + 1;
#line 516 "RequirementParser.c"
				}
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp3_ = FALSE;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp5_ = i;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp6_ = self->priv->_pos;
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 95 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					break;
#line 528 "RequirementParser.c"
				}
#line 96 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp7_ = buf;
#line 96 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				g_string_append_c (_tmp7_, '_');
#line 534 "RequirementParser.c"
			}
		}
	}
#line 97 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp8_ = buf;
#line 97 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_string_append_c (_tmp8_, '^');
#line 98 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	while (TRUE) {
#line 544 "RequirementParser.c"
		gint _tmp9_;
		GString* _tmp10_;
		gint _tmp11_;
#line 98 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp9_ = len;
#line 98 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (!(_tmp9_ > 1)) {
#line 98 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 554 "RequirementParser.c"
		}
#line 100 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp10_ = buf;
#line 100 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_string_append_c (_tmp10_, '^');
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp11_ = len;
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		len = _tmp11_ - 1;
#line 564 "RequirementParser.c"
	}
#line 103 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp12_ = buf;
#line 103 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_string_append_c (_tmp12_, '\n');
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp13_ = buf;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp14_ = _tmp13_->str;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp15_;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_string_free0 (buf);
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 582 "RequirementParser.c"
}


/**
     * Evaluate a list of requirements
     * 
     * @param requirements    The list of requirements  to parse and evaluate.
     * @return the result of the expression evaluation.
     * @throws ConditionalExpressionError on failure
     */
static gpointer _g_error_copy0 (gpointer self) {
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return self ? g_error_copy (self) : NULL;
#line 596 "RequirementParser.c"
}


gboolean drt_requirement_parser_eval (DrtRequirementParser* self, const gchar* requirements, gchar* * failed_requirements, GError** error) {
	gchar* _vala_failed_requirements = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
	gboolean _result_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (requirements != NULL, FALSE);
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (_vala_failed_requirements);
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_failed_requirements = NULL;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = requirements;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = strlen (_tmp0_);
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp2_ = _tmp1_;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->len = _tmp2_;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = requirements;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_data (self, _tmp3_);
#line 119 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_pos (self, 0);
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_text (self, NULL);
#line 121 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_pos (self, -1);
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_error_free0 (self->priv->error_object);
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->error_object = NULL;
#line 123 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_reset (self);
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp4_ = drt_requirement_parser_parse_all (self, &_vala_failed_requirements);
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_result_ = _tmp4_;
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp5_ = drt_requirement_parser_is_error_set (self);
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp5_) {
#line 651 "RequirementParser.c"
		GError* _tmp6_;
		GError* _tmp7_;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = self->priv->error_object;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp7_ = _g_error_copy0 (_tmp6_);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_inner_error_ = _tmp7_;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (_inner_error_->domain == DRT_REQUIREMENT_ERROR) {
#line 662 "RequirementParser.c"
			gboolean _tmp8_ = FALSE;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_propagate_error (error, _inner_error_);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return _tmp8_;
#line 668 "RequirementParser.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_clear_error (&_inner_error_);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return _tmp9_;
#line 677 "RequirementParser.c"
		}
	} else {
#line 128 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = _result_;
#line 128 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (failed_requirements) {
#line 128 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*failed_requirements = _vala_failed_requirements;
#line 686 "RequirementParser.c"
		} else {
#line 128 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (_vala_failed_requirements);
#line 690 "RequirementParser.c"
		}
#line 128 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 694 "RequirementParser.c"
	}
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (failed_requirements) {
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*failed_requirements = _vala_failed_requirements;
#line 700 "RequirementParser.c"
	} else {
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (_vala_failed_requirements);
#line 704 "RequirementParser.c"
	}
}


/**
     * Returns true if there has been an error.
     */
gboolean drt_requirement_parser_is_error_set (DrtRequirementParser* self) {
	gboolean result = FALSE;
	gint _tmp0_;
#line 134 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_error_pos;
#line 136 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp0_ >= 0;
#line 136 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 723 "RequirementParser.c"
}


/**
     * Perform an identifier call
     * 
     * @param pos       the position of the identifier
     * @param ident     the name of the identifier
     * @param params    the parameters
     * @return the result of the identifier call
     */
static gboolean drt_requirement_parser_real_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (ident != NULL, FALSE);
#line 149 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = params;
#line 149 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp0_ != NULL) {
#line 746 "RequirementParser.c"
		gint _tmp1_;
#line 150 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = pos;
#line 150 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_set_eval_error (self, _tmp1_, "Parameteres are not supported.", NULL);
#line 752 "RequirementParser.c"
	}
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = params;
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp3_ == NULL) {
#line 758 "RequirementParser.c"
		const gchar* _tmp4_;
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = ident;
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "false") != 0;
#line 764 "RequirementParser.c"
	} else {
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp2_ = FALSE;
#line 768 "RequirementParser.c"
	}
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp2_;
#line 151 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 774 "RequirementParser.c"
}


gboolean drt_requirement_parser_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params) {
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return DRT_REQUIREMENT_PARSER_GET_CLASS (self)->call (self, pos, ident, params);
#line 783 "RequirementParser.c"
}


/**
     * Reset the inner state before parsing and evaluation of a new expression.
     */
static void drt_requirement_parser_real_reset (DrtRequirementParser* self) {
}


void drt_requirement_parser_reset (DrtRequirementParser* self) {
#line 157 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 157 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	DRT_REQUIREMENT_PARSER_GET_CLASS (self)->reset (self);
#line 799 "RequirementParser.c"
}


/**
     * Set parse error
     * 
     * No identifier calls are evaluated when error is set.
     * 
     * @param pos     the position of the error
     * @param text    the text of the error
     * @param ...     Printf parameters
     * @return `false` as a convenience
     */
gboolean drt_requirement_parser_set_parse_error (DrtRequirementParser* self, gint pos, const gchar* text, ...) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 171 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = drt_requirement_parser_is_error_set (self);
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!_tmp0_) {
#line 824 "RequirementParser.c"
		gchar* error_text;
		const gchar* _tmp1_;
		va_list _tmp2_ = {0};
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		gint _tmp9_;
		const gchar* _tmp10_;
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = text;
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_start (_tmp2_, text);
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp3_ = g_strdup_vprintf (_tmp1_, _tmp2_);
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = _tmp3_;
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_end (_tmp2_);
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		error_text = _tmp4_;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp5_ = pos;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = error_text;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp7_ = g_error_new (DRT_REQUIREMENT_ERROR, DRT_REQUIREMENT_ERROR_PARSE, "%d: %s", _tmp5_, _tmp6_);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp8_ = _tmp7_;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp9_ = pos;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp10_ = error_text;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_set_error (self, _tmp8_, _tmp9_, _tmp10_);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_error_free0 (_tmp8_);
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (error_text);
#line 866 "RequirementParser.c"
	}
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = FALSE;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 872 "RequirementParser.c"
}


/**
     * Set syntax error
     * 
     * No identifier calls are evaluated when error is set.
     * 
     * @param pos     the position of the error
     * @param text    the text of the error
     * @param ...     Printf parameters
     * @return `false` as a convenience
     */
gboolean drt_requirement_parser_set_syntax_error (DrtRequirementParser* self, gint pos, const gchar* text, ...) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 191 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 191 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 193 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = drt_requirement_parser_is_error_set (self);
#line 193 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!_tmp0_) {
#line 897 "RequirementParser.c"
		gchar* error_text;
		const gchar* _tmp1_;
		va_list _tmp2_ = {0};
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		gint _tmp9_;
		const gchar* _tmp10_;
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = text;
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_start (_tmp2_, text);
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp3_ = g_strdup_vprintf (_tmp1_, _tmp2_);
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = _tmp3_;
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_end (_tmp2_);
#line 195 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		error_text = _tmp4_;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp5_ = pos;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = error_text;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp7_ = g_error_new (DRT_REQUIREMENT_ERROR, DRT_REQUIREMENT_ERROR_SYNTAX, "%d: %s", _tmp5_, _tmp6_);
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp8_ = _tmp7_;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp9_ = pos;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp10_ = error_text;
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_set_error (self, _tmp8_, _tmp9_, _tmp10_);
#line 196 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_error_free0 (_tmp8_);
#line 193 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (error_text);
#line 939 "RequirementParser.c"
	}
#line 198 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = FALSE;
#line 198 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 945 "RequirementParser.c"
}


/**
     * Set evaluation error
     * 
     * No identifier calls are evaluated when error is set.
     * 
     * @param pos     the position of the error
     * @param text    the text of the error
     * @param ...     Printf parameters
     * @return `false` as a convenience
     */
gboolean drt_requirement_parser_set_eval_error (DrtRequirementParser* self, gint pos, const gchar* text, ...) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 211 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 213 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = drt_requirement_parser_is_error_set (self);
#line 213 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!_tmp0_) {
#line 970 "RequirementParser.c"
		gchar* error_text;
		const gchar* _tmp1_;
		va_list _tmp2_ = {0};
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		const gchar* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		gint _tmp9_;
		const gchar* _tmp10_;
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = text;
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_start (_tmp2_, text);
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp3_ = g_strdup_vprintf (_tmp1_, _tmp2_);
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = _tmp3_;
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		va_end (_tmp2_);
#line 215 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		error_text = _tmp4_;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp5_ = pos;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = error_text;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp7_ = g_error_new (DRT_REQUIREMENT_ERROR, DRT_REQUIREMENT_ERROR_EVAL, "%d: %s", _tmp5_, _tmp6_);
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp8_ = _tmp7_;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp9_ = pos;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp10_ = error_text;
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_set_error (self, _tmp8_, _tmp9_, _tmp10_);
#line 216 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_error_free0 (_tmp8_);
#line 213 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (error_text);
#line 1012 "RequirementParser.c"
	}
#line 218 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = FALSE;
#line 218 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 1018 "RequirementParser.c"
}


static void drt_requirement_parser_set_error (DrtRequirementParser* self, GError* err, gint pos, const gchar* text) {
	GError* _tmp0_;
	GError* _tmp1_;
	gint _tmp2_;
	const gchar* _tmp3_;
#line 221 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 221 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (text != NULL);
#line 223 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = err;
#line 223 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = _g_error_copy0 (_tmp0_);
#line 223 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_error_free0 (self->priv->error_object);
#line 223 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->error_object = _tmp1_;
#line 224 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp2_ = pos;
#line 224 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_pos (self, _tmp2_);
#line 225 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = text;
#line 225 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_set_error_text (self, _tmp3_);
#line 1047 "RequirementParser.c"
}


static gboolean drt_requirement_parser_wrong_token (DrtRequirementParser* self, gint pos, DrtRequirementParserToks found, const gchar* expected) {
	gboolean result = FALSE;
	DrtRequirementParserToks _tmp0_;
#line 228 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 230 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = found;
#line 230 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	switch (_tmp0_) {
#line 230 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		case DRT_REQUIREMENT_PARSER_TOKS_NONE:
#line 1062 "RequirementParser.c"
		{
			gint _tmp1_;
			const gchar* _tmp2_;
#line 233 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp1_ = pos;
#line 233 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp2_ = expected;
#line 233 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			drt_requirement_parser_set_parse_error (self, _tmp1_, "Unknown token. %s expected.", _tmp2_, NULL);
#line 234 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 1074 "RequirementParser.c"
		}
#line 230 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		case DRT_REQUIREMENT_PARSER_TOKS_EOF:
#line 1078 "RequirementParser.c"
		{
			gint _tmp3_;
			const gchar* _tmp4_;
#line 236 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp3_ = pos;
#line 236 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp4_ = expected;
#line 236 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			drt_requirement_parser_set_parse_error (self, _tmp3_, "Unexpected end of data. %s expected.", _tmp4_, NULL);
#line 237 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 1090 "RequirementParser.c"
		}
		default:
		{
			gint _tmp5_;
			DrtRequirementParserToks _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			const gchar* _tmp9_;
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp5_ = pos;
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp6_ = found;
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp7_ = drt_requirement_parser_toks_to_str (_tmp6_);
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp8_ = _tmp7_;
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp9_ = expected;
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			drt_requirement_parser_set_syntax_error (self, _tmp5_, "Unexpected token %s. %s expected.", _tmp8_, _tmp9_, NULL);
#line 239 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (_tmp8_);
#line 240 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 1115 "RequirementParser.c"
		}
	}
#line 242 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = FALSE;
#line 242 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 1122 "RequirementParser.c"
}


static gboolean drt_requirement_parser_next (DrtRequirementParser* self, DrtRequirementParserToks* tok, gchar* * val, gint* position) {
	DrtRequirementParserToks _vala_tok = 0;
	gchar* _vala_val = NULL;
	gint _vala_position = 0;
	gboolean result = FALSE;
	DrtRequirementParserToks _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = drt_requirement_parser_peek (self, &_tmp0_, &_tmp1_, &_tmp2_);
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_tok = _tmp0_;
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (_vala_val);
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_val = _tmp1_;
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_position = _tmp2_;
#line 247 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp3_) {
#line 1149 "RequirementParser.c"
		gboolean _tmp4_;
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = drt_requirement_parser_skip (self);
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = _tmp4_;
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (tok) {
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*tok = _vala_tok;
#line 1159 "RequirementParser.c"
		}
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (val) {
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*val = _vala_val;
#line 1165 "RequirementParser.c"
		} else {
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (_vala_val);
#line 1169 "RequirementParser.c"
		}
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (position) {
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*position = _vala_position;
#line 1175 "RequirementParser.c"
		}
#line 248 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1179 "RequirementParser.c"
	} else {
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = FALSE;
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (tok) {
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*tok = _vala_tok;
#line 1187 "RequirementParser.c"
		}
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (val) {
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*val = _vala_val;
#line 1193 "RequirementParser.c"
		} else {
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (_vala_val);
#line 1197 "RequirementParser.c"
		}
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (position) {
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*position = _vala_position;
#line 1203 "RequirementParser.c"
		}
#line 250 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1207 "RequirementParser.c"
	}
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (tok) {
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*tok = _vala_tok;
#line 1213 "RequirementParser.c"
	}
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (val) {
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*val = _vala_val;
#line 1219 "RequirementParser.c"
	} else {
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (_vala_val);
#line 1223 "RequirementParser.c"
	}
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (position) {
#line 245 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*position = _vala_position;
#line 1229 "RequirementParser.c"
	}
}


static gboolean drt_requirement_parser_skip (DrtRequirementParser* self) {
	gboolean result = FALSE;
	gint _tmp0_;
	gboolean _tmp3_;
#line 253 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->peeked_token_len;
#line 255 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp0_ >= 0) {
#line 1244 "RequirementParser.c"
		gint _tmp1_;
		gint _tmp2_;
#line 257 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = self->priv->_pos;
#line 257 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp2_ = self->priv->peeked_token_len;
#line 257 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_set_pos (self, _tmp1_ + _tmp2_);
#line 258 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		self->priv->peeked_token_len = -1;
#line 259 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = TRUE;
#line 259 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1259 "RequirementParser.c"
	}
#line 261 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = drt_requirement_parser_next (self, NULL, NULL, NULL);
#line 261 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp3_;
#line 261 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 1267 "RequirementParser.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	return result;
#line 1285 "RequirementParser.c"
}


static gboolean drt_requirement_parser_peek (DrtRequirementParser* self, DrtRequirementParserToks* tok, gchar* * val, gint* position) {
	DrtRequirementParserToks _vala_tok = 0;
	gchar* _vala_val = NULL;
	gint _vala_position = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	GError * _inner_error_ = NULL;
#line 264 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (_vala_val);
#line 266 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_val = NULL;
#line 267 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_pos;
#line 267 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_position = _tmp0_;
#line 268 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->peeked_token_len = -1;
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	while (TRUE) {
#line 1310 "RequirementParser.c"
		gint _tmp1_;
		gint _tmp2_;
		GMatchInfo* mi = NULL;
		DrtRequirementParserToks _tmp35_;
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp1_ = self->priv->_pos;
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp2_ = self->priv->len;
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (!(_tmp1_ < _tmp2_)) {
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 1323 "RequirementParser.c"
		}
#line 271 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_vala_tok = DRT_REQUIREMENT_PARSER_TOKS_NONE;
#line 1327 "RequirementParser.c"
		{
			gboolean _tmp3_;
			GRegex* _tmp4_;
			const gchar* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GMatchInfo* _tmp8_ = NULL;
			gboolean _tmp9_;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp4_ = self->priv->patterns;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp5_ = self->priv->_data;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp6_ = self->priv->len;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp7_ = self->priv->_pos;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp9_ = g_regex_match_full (_tmp4_, _tmp5_, (gssize) _tmp6_, _tmp7_, G_REGEX_MATCH_ANCHORED, &_tmp8_, &_inner_error_);
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_match_info_unref0 (mi);
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			mi = _tmp8_;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp3_ = _tmp9_;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1354 "RequirementParser.c"
				gboolean _tmp10_ = FALSE;
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				if (_inner_error_->domain == G_REGEX_ERROR) {
#line 1358 "RequirementParser.c"
					goto __catch50_g_regex_error;
				}
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_g_match_info_unref0 (mi);
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				g_clear_error (&_inner_error_);
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				return _tmp10_;
#line 1369 "RequirementParser.c"
			}
#line 275 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (_tmp3_) {
#line 1373 "RequirementParser.c"
				{
					gint i;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					i = 1;
#line 1378 "RequirementParser.c"
					{
						gboolean _tmp11_;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
						_tmp11_ = TRUE;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
						while (TRUE) {
#line 1385 "RequirementParser.c"
							gint _tmp13_;
							gchar* _result_;
							GMatchInfo* _tmp14_;
							gint _tmp15_;
							gchar* _tmp16_;
							gboolean _tmp17_ = FALSE;
							const gchar* _tmp18_;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							if (!_tmp11_) {
#line 1395 "RequirementParser.c"
								gint _tmp12_;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp12_ = i;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								i = _tmp12_ + 1;
#line 1401 "RequirementParser.c"
							}
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp11_ = FALSE;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp13_ = i;
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							if (!(_tmp13_ < ((gint) DRT_REQUIREMENT_PARSER_TOKS_EOF))) {
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								break;
#line 1411 "RequirementParser.c"
							}
#line 279 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp14_ = mi;
#line 279 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp15_ = i;
#line 279 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp16_ = g_match_info_fetch (_tmp14_, _tmp15_);
#line 279 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_result_ = _tmp16_;
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_tmp18_ = _result_;
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							if (_tmp18_ != NULL) {
#line 1425 "RequirementParser.c"
								const gchar* _tmp19_;
								gchar _tmp20_;
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp19_ = _result_;
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp20_ = string_get (_tmp19_, (glong) 0);
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp17_ = ((gint) _tmp20_) != 0;
#line 1434 "RequirementParser.c"
							} else {
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp17_ = FALSE;
#line 1438 "RequirementParser.c"
							}
#line 280 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							if (_tmp17_) {
#line 1442 "RequirementParser.c"
								gint _tmp21_;
								gchar* _tmp22_;
								DrtRequirementParserToks _tmp23_;
								gint _tmp27_;
								const gchar* _tmp28_;
								gint _tmp29_;
								gint _tmp30_;
								gint _tmp31_;
#line 282 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp21_ = i;
#line 282 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_vala_tok = (DrtRequirementParserToks) _tmp21_;
#line 283 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp22_ = _result_;
#line 283 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_result_ = NULL;
#line 283 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_g_free0 (_vala_val);
#line 283 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_vala_val = _tmp22_;
#line 284 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp23_ = _vala_tok;
#line 284 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								if (_tmp23_ != DRT_REQUIREMENT_PARSER_TOKS_SPACE) {
#line 1467 "RequirementParser.c"
									const gchar* _tmp24_;
									gint _tmp25_;
									gint _tmp26_;
#line 286 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									_tmp24_ = _vala_val;
#line 286 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									_tmp25_ = strlen (_tmp24_);
#line 286 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									_tmp26_ = _tmp25_;
#line 286 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									self->priv->peeked_token_len = _tmp26_;
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									result = TRUE;
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									_g_free0 (_result_);
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									_g_match_info_unref0 (mi);
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									if (tok) {
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
										*tok = _vala_tok;
#line 1489 "RequirementParser.c"
									}
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									if (val) {
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
										*val = _vala_val;
#line 1495 "RequirementParser.c"
									} else {
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
										_g_free0 (_vala_val);
#line 1499 "RequirementParser.c"
									}
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									if (position) {
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
										*position = _vala_position;
#line 1505 "RequirementParser.c"
									}
#line 287 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
									return result;
#line 1509 "RequirementParser.c"
								}
#line 289 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp27_ = self->priv->_pos;
#line 289 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp28_ = _vala_val;
#line 289 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp29_ = strlen (_tmp28_);
#line 289 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp30_ = _tmp29_;
#line 289 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								drt_requirement_parser_set_pos (self, _tmp27_ + _tmp30_);
#line 290 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_tmp31_ = self->priv->_pos;
#line 290 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_vala_position = _tmp31_;
#line 291 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								_g_free0 (_result_);
#line 291 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
								break;
#line 1529 "RequirementParser.c"
							}
#line 277 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
							_g_free0 (_result_);
#line 1533 "RequirementParser.c"
						}
					}
				}
			}
		}
		goto __finally50;
		__catch50_g_regex_error:
		{
			GError* e = NULL;
			GError* _tmp32_;
			const gchar* _tmp33_;
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			e = _inner_error_;
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_inner_error_ = NULL;
#line 298 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp32_ = e;
#line 298 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp33_ = _tmp32_->message;
#line 298 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_critical ("RequirementParser.vala:298: Regex error: %s", _tmp33_);
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_error_free0 (e);
#line 1557 "RequirementParser.c"
		}
		__finally50:
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1562 "RequirementParser.c"
			gboolean _tmp34_ = FALSE;
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_match_info_unref0 (mi);
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			g_clear_error (&_inner_error_);
#line 273 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return _tmp34_;
#line 1572 "RequirementParser.c"
		}
#line 300 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp35_ = _vala_tok;
#line 300 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (_tmp35_ != DRT_REQUIREMENT_PARSER_TOKS_SPACE) {
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			result = FALSE;
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_match_info_unref0 (mi);
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (tok) {
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				*tok = _vala_tok;
#line 1586 "RequirementParser.c"
			}
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (val) {
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				*val = _vala_val;
#line 1592 "RequirementParser.c"
			} else {
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_g_free0 (_vala_val);
#line 1596 "RequirementParser.c"
			}
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			if (position) {
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				*position = _vala_position;
#line 1602 "RequirementParser.c"
			}
#line 301 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return result;
#line 1606 "RequirementParser.c"
		}
#line 269 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_match_info_unref0 (mi);
#line 1610 "RequirementParser.c"
	}
#line 303 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_vala_tok = DRT_REQUIREMENT_PARSER_TOKS_EOF;
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = FALSE;
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (tok) {
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*tok = _vala_tok;
#line 1620 "RequirementParser.c"
	}
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (val) {
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*val = _vala_val;
#line 1626 "RequirementParser.c"
	} else {
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (_vala_val);
#line 1630 "RequirementParser.c"
	}
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (position) {
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*position = _vala_position;
#line 1636 "RequirementParser.c"
	}
#line 304 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 1640 "RequirementParser.c"
}


static gboolean drt_requirement_parser_parse_all (DrtRequirementParser* self, gchar* * failed_requirements) {
	gboolean result = FALSE;
	DrtRequirementParserToks tok;
	gchar* val = NULL;
	gint pos = 0;
	gboolean _result_;
	DrtRequirementParserToks _tmp12_;
#line 307 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 309 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	tok = DRT_REQUIREMENT_PARSER_TOKS_NONE;
#line 312 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_result_ = TRUE;
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	while (TRUE) {
#line 1659 "RequirementParser.c"
		DrtRequirementParserToks _tmp0_ = 0;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gboolean _tmp3_;
		DrtRequirementParserToks _tmp4_;
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp3_ = drt_requirement_parser_next (self, &_tmp0_, &_tmp1_, &_tmp2_);
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		tok = _tmp0_;
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (val);
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		val = _tmp1_;
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		pos = _tmp2_;
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (!_tmp3_) {
#line 313 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			break;
#line 1679 "RequirementParser.c"
		}
#line 315 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = tok;
#line 315 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		switch (_tmp4_) {
#line 315 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			case DRT_REQUIREMENT_PARSER_TOKS_SPACE:
#line 315 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			case DRT_REQUIREMENT_PARSER_TOKS_SEMICOLON:
#line 1689 "RequirementParser.c"
			{
#line 319 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				continue;
#line 1693 "RequirementParser.c"
			}
#line 315 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			case DRT_REQUIREMENT_PARSER_TOKS_IDENT:
#line 1697 "RequirementParser.c"
			{
				gboolean _tmp5_ = FALSE;
				gint _tmp6_;
				const gchar* _tmp7_;
				gboolean _tmp8_;
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp6_ = pos;
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp7_ = val;
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp8_ = drt_requirement_parser_parse_rule (self, _tmp6_, _tmp7_, failed_requirements);
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				if (_tmp8_) {
#line 1711 "RequirementParser.c"
					gboolean _tmp9_;
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					_tmp9_ = _result_;
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					_tmp5_ = _tmp9_;
#line 1717 "RequirementParser.c"
				} else {
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
					_tmp5_ = FALSE;
#line 1721 "RequirementParser.c"
				}
#line 321 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_result_ = _tmp5_;
#line 322 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				break;
#line 1727 "RequirementParser.c"
			}
			default:
			{
				gint _tmp10_;
				DrtRequirementParserToks _tmp11_;
#line 324 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp10_ = pos;
#line 324 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				_tmp11_ = tok;
#line 324 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				drt_requirement_parser_wrong_token (self, _tmp10_, _tmp11_, "One of SPACE, SEMICOLON, IDENT tokens");
#line 325 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
				break;
#line 1741 "RequirementParser.c"
			}
		}
	}
#line 328 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp12_ = tok;
#line 328 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp12_ == DRT_REQUIREMENT_PARSER_TOKS_EOF) {
#line 329 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = _result_;
#line 329 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (val);
#line 329 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1755 "RequirementParser.c"
	} else {
		gint _tmp13_;
		DrtRequirementParserToks _tmp14_;
		gboolean _tmp15_;
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp13_ = pos;
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp14_ = tok;
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp15_ = drt_requirement_parser_wrong_token (self, _tmp13_, _tmp14_, "EOF token");
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = _tmp15_;
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (val);
#line 331 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1772 "RequirementParser.c"
	}
#line 307 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (val);
#line 1776 "RequirementParser.c"
}


static gboolean drt_requirement_parser_parse_rule (DrtRequirementParser* self, gint pos, const gchar* ident, gchar* * failed_requirements) {
	gboolean result = FALSE;
	DrtRequirementParserToks tok;
	gchar* params = NULL;
	gboolean _tmp0_ = FALSE;
	DrtRequirementParserToks _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	gint _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp18_;
#line 334 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 334 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (ident != NULL, FALSE);
#line 336 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	tok = DRT_REQUIREMENT_PARSER_TOKS_NONE;
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = drt_requirement_parser_peek (self, &_tmp1_, &_tmp2_, NULL);
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	tok = _tmp1_;
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (params);
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	params = _tmp2_;
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp3_) {
#line 1807 "RequirementParser.c"
		DrtRequirementParserToks _tmp4_;
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp4_ = tok;
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp0_ = _tmp4_ == DRT_REQUIREMENT_PARSER_TOKS_PARAMS;
#line 1813 "RequirementParser.c"
	} else {
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp0_ = FALSE;
#line 1817 "RequirementParser.c"
	}
#line 338 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp0_) {
#line 1821 "RequirementParser.c"
		gint len;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gboolean _tmp15_;
#line 340 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_skip (self);
#line 341 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp5_ = params;
#line 341 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = strlen (_tmp5_);
#line 341 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp7_ = _tmp6_;
#line 341 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		len = _tmp7_;
#line 342 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp8_ = len;
#line 342 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (_tmp8_ > 2) {
#line 1845 "RequirementParser.c"
			const gchar* _tmp9_;
			gint _tmp10_;
			gchar* _tmp11_;
#line 343 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp9_ = params;
#line 343 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp10_ = len;
#line 343 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp11_ = string_substring (_tmp9_, (glong) 1, (glong) (_tmp10_ - 2));
#line 343 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (params);
#line 343 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			params = _tmp11_;
#line 1859 "RequirementParser.c"
		} else {
#line 345 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (params);
#line 345 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			params = NULL;
#line 1865 "RequirementParser.c"
		}
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp12_ = pos;
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp13_ = ident;
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp14_ = params;
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp15_ = drt_requirement_parser_parse_call (self, _tmp12_, _tmp13_, _tmp14_, failed_requirements);
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = _tmp15_;
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (params);
#line 346 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1881 "RequirementParser.c"
	}
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp16_ = pos;
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp17_ = ident;
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp18_ = drt_requirement_parser_parse_call (self, _tmp16_, _tmp17_, NULL, failed_requirements);
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp18_;
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (params);
#line 348 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 1895 "RequirementParser.c"
}


static gboolean drt_requirement_parser_parse_call (DrtRequirementParser* self, gint pos, const gchar* ident, const gchar* params, gchar* * failed_requirements) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _result_;
	gint _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 351 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (ident != NULL, FALSE);
#line 353 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = drt_requirement_parser_is_error_set (self);
#line 353 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (_tmp0_) {
#line 354 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		result = FALSE;
#line 354 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return result;
#line 1920 "RequirementParser.c"
	}
#line 356 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = pos;
#line 356 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp2_ = ident;
#line 356 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp3_ = params;
#line 356 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp4_ = drt_requirement_parser_call (self, _tmp1_, _tmp2_, _tmp3_);
#line 356 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_result_ = _tmp4_;
#line 357 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp5_ = _result_;
#line 357 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!_tmp5_) {
#line 1936 "RequirementParser.c"
		const gchar* _tmp6_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 359 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp6_ = *failed_requirements;
#line 359 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (_tmp6_ == NULL) {
#line 1949 "RequirementParser.c"
			gchar* _tmp7_;
#line 360 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp7_ = g_strdup ("");
#line 360 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (*failed_requirements);
#line 360 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*failed_requirements = _tmp7_;
#line 1957 "RequirementParser.c"
		} else {
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 362 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp8_ = *failed_requirements;
#line 362 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp9_ = g_strconcat (_tmp8_, " ", NULL);
#line 362 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_g_free0 (*failed_requirements);
#line 362 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			*failed_requirements = _tmp9_;
#line 1969 "RequirementParser.c"
		}
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp11_ = params;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp10_ = _tmp11_;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (_tmp10_ == NULL) {
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			_tmp10_ = "";
#line 1979 "RequirementParser.c"
		}
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp12_ = *failed_requirements;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp13_ = ident;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp14_ = g_strdup_printf ("%s[%s]", _tmp13_, _tmp10_);
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp15_ = _tmp14_;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (*failed_requirements);
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*failed_requirements = _tmp16_;
#line 363 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		_g_free0 (_tmp15_);
#line 1997 "RequirementParser.c"
	}
#line 365 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _result_;
#line 365 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 2003 "RequirementParser.c"
}


const gchar* drt_requirement_parser_get_data (DrtRequirementParser* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_data;
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp0_;
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 2018 "RequirementParser.c"
}


static void drt_requirement_parser_set_data (DrtRequirementParser* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = value;
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (self->priv->_data);
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->_data = _tmp1_;
#line 2035 "RequirementParser.c"
}


gint drt_requirement_parser_get_pos (DrtRequirementParser* self) {
	gint result;
	gint _tmp0_;
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_pos;
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp0_;
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 2050 "RequirementParser.c"
}


static void drt_requirement_parser_set_pos (DrtRequirementParser* self, gint value) {
	gint _tmp0_;
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = value;
#line 51 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->_pos = _tmp0_;
#line 2062 "RequirementParser.c"
}


gint drt_requirement_parser_get_error_pos (DrtRequirementParser* self) {
	gint result;
	gint _tmp0_;
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_error_pos;
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp0_;
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 2077 "RequirementParser.c"
}


static void drt_requirement_parser_set_error_pos (DrtRequirementParser* self, gint value) {
	gint _tmp0_;
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = value;
#line 53 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->_error_pos = _tmp0_;
#line 2089 "RequirementParser.c"
}


const gchar* drt_requirement_parser_get_error_text (DrtRequirementParser* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = self->priv->_error_text;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	result = _tmp0_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return result;
#line 2104 "RequirementParser.c"
}


static void drt_requirement_parser_set_error_text (DrtRequirementParser* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp0_ = value;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (self->priv->_error_text);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv->_error_text = _tmp1_;
#line 2121 "RequirementParser.c"
}


static void drt_value_requirement_parser_init (GValue* value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	value->data[0].v_pointer = NULL;
#line 2128 "RequirementParser.c"
}


static void drt_value_requirement_parser_free_value (GValue* value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_unref (value->data[0].v_pointer);
#line 2137 "RequirementParser.c"
	}
}


static void drt_value_requirement_parser_copy_value (const GValue* src_value, GValue* dest_value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (src_value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		dest_value->data[0].v_pointer = drt_requirement_parser_ref (src_value->data[0].v_pointer);
#line 2147 "RequirementParser.c"
	} else {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2151 "RequirementParser.c"
	}
}


static gpointer drt_value_requirement_parser_peek_pointer (const GValue* value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return value->data[0].v_pointer;
#line 2159 "RequirementParser.c"
}


static gchar* drt_value_requirement_parser_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (collect_values[0].v_pointer) {
#line 2166 "RequirementParser.c"
		DrtRequirementParser * object;
		object = collect_values[0].v_pointer;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		if (object->parent_instance.g_class == NULL) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2173 "RequirementParser.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2177 "RequirementParser.c"
		}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = drt_requirement_parser_ref (object);
#line 2181 "RequirementParser.c"
	} else {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = NULL;
#line 2185 "RequirementParser.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return NULL;
#line 2189 "RequirementParser.c"
}


static gchar* drt_value_requirement_parser_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtRequirementParser ** object_p;
	object_p = collect_values[0].v_pointer;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!object_p) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2200 "RequirementParser.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (!value->data[0].v_pointer) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*object_p = NULL;
#line 2206 "RequirementParser.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*object_p = value->data[0].v_pointer;
#line 2210 "RequirementParser.c"
	} else {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		*object_p = drt_requirement_parser_ref (value->data[0].v_pointer);
#line 2214 "RequirementParser.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return NULL;
#line 2218 "RequirementParser.c"
}


GParamSpec* drt_param_spec_requirement_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecRequirementParser* spec;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_REQUIREMENT_PARSER), NULL);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return G_PARAM_SPEC (spec);
#line 2232 "RequirementParser.c"
}


gpointer drt_value_get_requirement_parser (const GValue* value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_REQUIREMENT_PARSER), NULL);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return value->data[0].v_pointer;
#line 2241 "RequirementParser.c"
}


void drt_value_set_requirement_parser (GValue* value, gpointer v_object) {
	DrtRequirementParser * old;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_REQUIREMENT_PARSER));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	old = value->data[0].v_pointer;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (v_object) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_REQUIREMENT_PARSER));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = v_object;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_ref (value->data[0].v_pointer);
#line 2261 "RequirementParser.c"
	} else {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = NULL;
#line 2265 "RequirementParser.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (old) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_unref (old);
#line 2271 "RequirementParser.c"
	}
}


void drt_value_take_requirement_parser (GValue* value, gpointer v_object) {
	DrtRequirementParser * old;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_REQUIREMENT_PARSER));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	old = value->data[0].v_pointer;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (v_object) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_REQUIREMENT_PARSER));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = v_object;
#line 2290 "RequirementParser.c"
	} else {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		value->data[0].v_pointer = NULL;
#line 2294 "RequirementParser.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (old) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		drt_requirement_parser_unref (old);
#line 2300 "RequirementParser.c"
	}
}


static void drt_requirement_parser_class_init (DrtRequirementParserClass * klass) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	drt_requirement_parser_parent_class = g_type_class_peek_parent (klass);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	((DrtRequirementParserClass *) klass)->finalize = drt_requirement_parser_finalize;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_type_class_add_private (klass, sizeof (DrtRequirementParserPrivate));
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	((DrtRequirementParserClass *) klass)->call = (gboolean (*) (DrtRequirementParser *, gint, const gchar*, const gchar*)) drt_requirement_parser_real_call;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	((DrtRequirementParserClass *) klass)->reset = (void (*) (DrtRequirementParser *)) drt_requirement_parser_real_reset;
#line 2316 "RequirementParser.c"
}


static void drt_requirement_parser_instance_init (DrtRequirementParser * self) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->priv = DRT_REQUIREMENT_PARSER_GET_PRIVATE (self);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self->ref_count = 1;
#line 2325 "RequirementParser.c"
}


static void drt_requirement_parser_finalize (DrtRequirementParser * obj) {
	DrtRequirementParser * self;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_REQUIREMENT_PARSER, DrtRequirementParser);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_signal_handlers_destroy (self);
#line 49 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (self->priv->_data);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_free0 (self->priv->_error_text);
#line 56 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_error_free0 (self->priv->error_object);
#line 58 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	_g_regex_unref0 (self->priv->patterns);
#line 2343 "RequirementParser.c"
}


/**
 * Parser and evaluator of a list of requirements.
 * 
 * A requirement consist of a name and optional parameters in square brackets.
 * Requirements are separated with whitespace or a semicolon. 
 * Example: "webkitgtk[2.15.3] codec[mp3] codec[h264] feature[mse]" 
 */
GType drt_requirement_parser_get_type (void) {
	static volatile gsize drt_requirement_parser_type_id__volatile = 0;
	if (g_once_init_enter (&drt_requirement_parser_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_requirement_parser_init, drt_value_requirement_parser_free_value, drt_value_requirement_parser_copy_value, drt_value_requirement_parser_peek_pointer, "p", drt_value_requirement_parser_collect_value, "p", drt_value_requirement_parser_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtRequirementParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_requirement_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRequirementParser), 0, (GInstanceInitFunc) drt_requirement_parser_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_requirement_parser_type_id;
		drt_requirement_parser_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtRequirementParser", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_requirement_parser_type_id__volatile, drt_requirement_parser_type_id);
	}
	return drt_requirement_parser_type_id__volatile;
}


gpointer drt_requirement_parser_ref (gpointer instance) {
	DrtRequirementParser * self;
	self = instance;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	g_atomic_int_inc (&self->ref_count);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	return instance;
#line 2375 "RequirementParser.c"
}


void drt_requirement_parser_unref (gpointer instance) {
	DrtRequirementParser * self;
	self = instance;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		DRT_REQUIREMENT_PARSER_GET_CLASS (self)->finalize (self);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/RequirementParser.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2388 "RequirementParser.c"
	}
}



