/* Storage.c generated by valac 0.36.2, the Vala compiler
 * generated from Storage.vala, do not modify */

/*
 * Copyright 2011-2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DIORITE_TYPE_STORAGE (diorite_storage_get_type ())
#define DIORITE_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_STORAGE, DioriteStorage))
#define DIORITE_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_STORAGE, DioriteStorageClass))
#define DIORITE_IS_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_STORAGE))
#define DIORITE_IS_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_STORAGE))
#define DIORITE_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_STORAGE, DioriteStorageClass))

typedef struct _DioriteStorage DioriteStorage;
typedef struct _DioriteStorageClass DioriteStorageClass;
typedef struct _DioriteStoragePrivate DioriteStoragePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DIORITE_TYPE_XDG_STORAGE (diorite_xdg_storage_get_type ())
#define DIORITE_XDG_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorage))
#define DIORITE_XDG_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorageClass))
#define DIORITE_IS_XDG_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIORITE_TYPE_XDG_STORAGE))
#define DIORITE_IS_XDG_STORAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIORITE_TYPE_XDG_STORAGE))
#define DIORITE_XDG_STORAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIORITE_TYPE_XDG_STORAGE, DioriteXdgStorageClass))

typedef struct _DioriteXdgStorage DioriteXdgStorage;
typedef struct _DioriteXdgStorageClass DioriteXdgStorageClass;
typedef struct _DioriteXdgStoragePrivate DioriteXdgStoragePrivate;

struct _DioriteStorage {
	GObject parent_instance;
	DioriteStoragePrivate * priv;
	GFile** _data_dirs;
	gint _data_dirs_length1;
};

struct _DioriteStorageClass {
	GObjectClass parent_class;
};

struct _DioriteStoragePrivate {
	GFile* _user_data_dir;
	GFile* _user_cache_dir;
	GFile* _user_config_dir;
};

struct _DioriteXdgStorage {
	DioriteStorage parent_instance;
	DioriteXdgStoragePrivate * priv;
};

struct _DioriteXdgStorageClass {
	DioriteStorageClass parent_class;
};


static gpointer diorite_storage_parent_class = NULL;
static gpointer diorite_xdg_storage_parent_class = NULL;

GType diorite_storage_get_type (void) G_GNUC_CONST;
#define DIORITE_STORAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIORITE_TYPE_STORAGE, DioriteStoragePrivate))
enum  {
	DIORITE_STORAGE_DUMMY_PROPERTY,
	DIORITE_STORAGE_USER_DATA_DIR,
	DIORITE_STORAGE_USER_CACHE_DIR,
	DIORITE_STORAGE_USER_CONFIG_DIR
};
DioriteStorage* diorite_storage_new (const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir);
DioriteStorage* diorite_storage_construct (GType object_type, const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir);
void diorite_storage_set_user_data_dir (DioriteStorage* self, GFile* value);
void diorite_storage_set_user_config_dir (DioriteStorage* self, GFile* value);
void diorite_storage_set_user_cache_dir (DioriteStorage* self, GFile* value);
static void _vala_array_add1 (GFile** * array, int* length, int* size, GFile* value);
static GFile** _vala_array_dup3 (GFile** self, int length);
DioriteStorage* diorite_storage_get_child (DioriteStorage* self, const gchar* id);
static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value);
GFile* diorite_storage_get_user_data_dir (DioriteStorage* self);
GFile* diorite_storage_get_user_config_dir (DioriteStorage* self);
GFile* diorite_storage_get_user_cache_dir (DioriteStorage* self);
GFile* diorite_storage_get_config_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_cache_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_data_path (DioriteStorage* self, const gchar* path);
GFile* diorite_storage_get_data_file (DioriteStorage* self, const gchar* name);
GFile** diorite_storage_get_data_dirs (DioriteStorage* self, int* result_length1);
static void _vala_array_add3 (GFile** * array, int* length, int* size, GFile* value);
static void diorite_storage_finalize (GObject * obj);
static void _vala_diorite_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_diorite_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType diorite_xdg_storage_get_type (void) G_GNUC_CONST;
enum  {
	DIORITE_XDG_STORAGE_DUMMY_PROPERTY
};
DioriteXdgStorage* diorite_xdg_storage_new (void);
DioriteXdgStorage* diorite_xdg_storage_construct (GType object_type);
DioriteXdgStorage* diorite_xdg_storage_new_for_project (const gchar* id, const gchar* user_suffix);
DioriteXdgStorage* diorite_xdg_storage_construct_for_project (GType object_type, const gchar* id, const gchar* user_suffix);
static void _vala_array_add4 (GFile** * array, int* length, int* size, GFile* value);
static GFile** _vala_array_dup4 (GFile** self, int length);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Creates new storage
 * 
 * @param user_data_dir      Directory for user's data
 * @param data_dirs          System data directories
 * @param user_config_dir    Directory for user's configuration
 * @param user_cache_dir     Directory for user's cached files
 */
static void _vala_array_add1 (GFile** * array, int* length, int* size, GFile* value) {
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if ((*length) == (*size)) {
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 149 "Storage.c"
	}
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[(*length)++] = value;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[*length] = NULL;
#line 155 "Storage.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return self ? g_object_ref (self) : NULL;
#line 162 "Storage.c"
}


static GFile** _vala_array_dup3 (GFile** self, int length) {
	GFile** result;
	int i;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = g_new0 (GFile*, length + 1);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	for (i = 0; i < length; i++) {
#line 173 "Storage.c"
		GFile* _tmp0_;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp0_ = _g_object_ref0 (self[i]);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		result[i] = _tmp0_;
#line 179 "Storage.c"
	}
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 183 "Storage.c"
}


DioriteStorage* diorite_storage_construct (GType object_type, const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir) {
	DioriteStorage * self = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile** _data_dirs;
	GFile** _tmp9_;
	gint _data_dirs_length1;
	gint __data_dirs_size_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GFile** _tmp15_;
	gint _tmp15__length1;
	GFile** _tmp16_;
	gint _tmp16__length1;
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (user_data_dir != NULL, NULL);
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (user_config_dir != NULL, NULL);
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (user_cache_dir != NULL, NULL);
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self = (DioriteStorage*) g_object_new (object_type, NULL);
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = user_data_dir;
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = _tmp1_;
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_data_dir (self, _tmp2_);
#line 68 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp2_);
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp3_ = user_config_dir;
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp5_ = _tmp4_;
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_config_dir (self, _tmp5_);
#line 69 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp5_);
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp6_ = user_cache_dir;
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp7_ = g_file_new_for_path (_tmp6_);
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp8_ = _tmp7_;
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_cache_dir (self, _tmp8_);
#line 70 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp8_);
#line 72 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp9_ = g_new0 (GFile*, 0 + 1);
#line 72 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_data_dirs = _tmp9_;
#line 72 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_data_dirs_length1 = 0;
#line 72 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	__data_dirs_size_ = _data_dirs_length1;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp10_ = data_dirs;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp10__length1 = data_dirs_length1;
#line 258 "Storage.c"
	{
		gchar** path_collection = NULL;
		gint path_collection_length1 = 0;
		gint _path_collection_size_ = 0;
		gint path_it = 0;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		path_collection = _tmp10_;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		path_collection_length1 = _tmp10__length1;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		for (path_it = 0; path_it < _tmp10__length1; path_it = path_it + 1) {
#line 270 "Storage.c"
			gchar* _tmp11_;
			gchar* path = NULL;
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			_tmp11_ = g_strdup (path_collection[path_it]);
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			path = _tmp11_;
#line 277 "Storage.c"
			{
				GFile** _tmp12_;
				gint _tmp12__length1;
				const gchar* _tmp13_;
				GFile* _tmp14_;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp12_ = _data_dirs;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp12__length1 = _data_dirs_length1;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp13_ = path;
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp14_ = g_file_new_for_path (_tmp13_);
#line 74 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_vala_array_add1 (&_data_dirs, &_data_dirs_length1, &__data_dirs_size_, _tmp14_);
#line 73 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_free0 (path);
#line 295 "Storage.c"
			}
		}
	}
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp15_ = _data_dirs;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp15__length1 = _data_dirs_length1;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp16_ = (_tmp15_ != NULL) ? _vala_array_dup3 (_tmp15_, _tmp15__length1) : ((gpointer) _tmp15_);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp16__length1 = _tmp15__length1;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self->_data_dirs = (_vala_array_free (self->_data_dirs, self->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self->_data_dirs = _tmp16_;
#line 76 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self->_data_dirs_length1 = _tmp16__length1;
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_data_dirs = (_vala_array_free (_data_dirs, _data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return self;
#line 317 "Storage.c"
}


DioriteStorage* diorite_storage_new (const gchar* user_data_dir, gchar** data_dirs, int data_dirs_length1, const gchar* user_config_dir, const gchar* user_cache_dir) {
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return diorite_storage_construct (DIORITE_TYPE_STORAGE, user_data_dir, data_dirs, data_dirs_length1, user_config_dir, user_cache_dir);
#line 324 "Storage.c"
}


/**
 * Returns new child storage.
 * 
 * @param id    child storage id
 * @return      child storage 
 */
static void _vala_array_add2 (gchar** * array, int* length, int* size, gchar* value) {
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if ((*length) == (*size)) {
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 341 "Storage.c"
	}
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[(*length)++] = value;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[*length] = NULL;
#line 347 "Storage.c"
}


DioriteStorage* diorite_storage_get_child (DioriteStorage* self, const gchar* id) {
	DioriteStorage* result = NULL;
	gchar** data_dirs;
	gchar** _tmp0_;
	gint data_dirs_length1;
	gint _data_dirs_size_;
	GFile** _tmp1_;
	gint _tmp1__length1;
	GFile* _tmp9_;
	const gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	GFile* _tmp16_;
	const gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GFile* _tmp22_;
	const gchar* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	DioriteStorage* _tmp28_;
	DioriteStorage* _tmp29_;
#line 85 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 87 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 87 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs = _tmp0_;
#line 87 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs_length1 = 0;
#line 87 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_data_dirs_size_ = data_dirs_length1;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = self->_data_dirs;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1__length1 = self->_data_dirs_length1;
#line 397 "Storage.c"
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection = _tmp1_;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection_length1 = _tmp1__length1;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		for (dir_it = 0; dir_it < _tmp1__length1; dir_it = dir_it + 1) {
#line 409 "Storage.c"
			GFile* _tmp2_;
			GFile* dir = NULL;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			_tmp2_ = _g_object_ref0 (dir_collection[dir_it]);
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			dir = _tmp2_;
#line 416 "Storage.c"
			{
				gchar** _tmp3_;
				gint _tmp3__length1;
				GFile* _tmp4_;
				const gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				gchar* _tmp8_;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp3_ = data_dirs;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp3__length1 = data_dirs_length1;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp4_ = dir;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp5_ = id;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp6_ = g_file_get_child (_tmp4_, _tmp5_);
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp7_ = _tmp6_;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp8_ = g_file_get_path (_tmp7_);
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_vala_array_add2 (&data_dirs, &data_dirs_length1, &_data_dirs_size_, _tmp8_);
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (_tmp7_);
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (dir);
#line 445 "Storage.c"
			}
		}
	}
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp9_ = self->priv->_user_data_dir;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp10_ = id;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp11_ = g_file_get_child (_tmp9_, _tmp10_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp12_ = _tmp11_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp14_ = _tmp13_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp15_ = data_dirs;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp15__length1 = data_dirs_length1;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp16_ = self->priv->_user_config_dir;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp17_ = id;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp18_ = g_file_get_child (_tmp16_, _tmp17_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp19_ = _tmp18_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp20_ = g_file_get_path (_tmp19_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp21_ = _tmp20_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp22_ = self->priv->_user_cache_dir;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp23_ = id;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp24_ = g_file_get_child (_tmp22_, _tmp23_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp25_ = _tmp24_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp26_ = g_file_get_path (_tmp25_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp27_ = _tmp26_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp28_ = diorite_storage_new (_tmp14_, _tmp15_, _tmp15__length1, _tmp21_, _tmp27_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp29_ = _tmp28_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp27_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp25_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp21_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp19_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp14_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp12_);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp29_;
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_free), NULL);
#line 91 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 511 "Storage.c"
}


/**
 * Returns the default path of configuration file/directory with given name
 * 
 * @param path Name of configuration file/directory
 * @return default configuration path
 */
GFile* diorite_storage_get_config_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_config_dir;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = path;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp2_;
#line 104 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 540 "Storage.c"
}


/**
 * Returns the default path of cache file/directory with given name
 * 
 * @param path
 * @return default cache path
 */
GFile* diorite_storage_get_cache_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
#line 113 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_cache_dir;
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = path;
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp2_;
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 569 "Storage.c"
}


/**
 * Returns the default path of data dir/file with given name
 * 
 * @param path
 * @return default data path
 */
GFile* diorite_storage_get_data_path (DioriteStorage* self, const gchar* path) {
	GFile* result = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_data_dir;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = path;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp2_;
#line 126 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 598 "Storage.c"
}


/**
 * Looks for a file in data directories. User's data directory has a precedence
 * over system data directories.
 * 
 * @param name name of the file
 * @return file instance or null if no file has been found
 */
GFile* diorite_storage_get_data_file (DioriteStorage* self, const gchar* name) {
	GFile* result = NULL;
	GFile* f;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFileType _tmp4_;
	GFile** _tmp5_;
	gint _tmp5__length1;
	GFile** _tmp6_;
	gint _tmp6__length1;
#line 136 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 136 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 138 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_data_dir;
#line 138 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = name;
#line 138 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = g_file_get_child (_tmp0_, _tmp1_);
#line 138 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	f = _tmp2_;
#line 139 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp3_ = f;
#line 139 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp4_ = g_file_query_file_type (_tmp3_, 0, NULL);
#line 139 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if (_tmp4_ == G_FILE_TYPE_REGULAR) {
#line 140 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		result = f;
#line 140 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		return result;
#line 643 "Storage.c"
	}
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp5_ = diorite_storage_get_data_dirs (self, &_tmp5__length1);
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp6_ = _tmp5_;
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp6__length1 = _tmp5__length1;
#line 651 "Storage.c"
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection = _tmp6_;
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection_length1 = _tmp6__length1;
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		for (dir_it = 0; dir_it < _tmp6__length1; dir_it = dir_it + 1) {
#line 663 "Storage.c"
			GFile* _tmp7_;
			GFile* dir = NULL;
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			_tmp7_ = _g_object_ref0 (dir_collection[dir_it]);
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			dir = _tmp7_;
#line 670 "Storage.c"
			{
				GFile* _tmp8_;
				const gchar* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				GFileType _tmp12_;
#line 143 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp8_ = dir;
#line 143 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp9_ = name;
#line 143 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp10_ = g_file_get_child (_tmp8_, _tmp9_);
#line 143 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (f);
#line 143 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				f = _tmp10_;
#line 144 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp11_ = f;
#line 144 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp12_ = g_file_query_file_type (_tmp11_, 0, NULL);
#line 144 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				if (_tmp12_ == G_FILE_TYPE_REGULAR) {
#line 145 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					result = f;
#line 145 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_g_object_unref0 (dir);
#line 145 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 145 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					return result;
#line 701 "Storage.c"
				}
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (dir);
#line 705 "Storage.c"
			}
		}
#line 141 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection = (_vala_array_free (dir_collection, dir_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 710 "Storage.c"
	}
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = NULL;
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (f);
#line 147 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 718 "Storage.c"
}


GFile* diorite_storage_get_user_data_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_data_dir;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 733 "Storage.c"
}


void diorite_storage_set_user_data_dir (DioriteStorage* self, GFile* value) {
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if (diorite_storage_get_user_data_dir (self) != value) {
#line 742 "Storage.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp0_ = value;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_g_object_unref0 (self->priv->_user_data_dir);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		self->priv->_user_data_dir = _tmp1_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_object_notify ((GObject *) self, "user-data-dir");
#line 755 "Storage.c"
	}
}


static void _vala_array_add3 (GFile** * array, int* length, int* size, GFile* value) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if ((*length) == (*size)) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 767 "Storage.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[(*length)++] = value;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[*length] = NULL;
#line 773 "Storage.c"
}


GFile** diorite_storage_get_data_dirs (DioriteStorage* self, int* result_length1) {
	GFile** result;
	GFile** dirs;
	GFile** _tmp0_;
	gint dirs_length1;
	gint _dirs_size_;
	GFile** _tmp1_;
	gint _tmp1__length1;
	GFile** _tmp8_;
	gint _tmp8__length1;
#line 41 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 43 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	dirs = _tmp0_;
#line 43 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	dirs_length1 = 0;
#line 43 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_dirs_size_ = dirs_length1;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = self->_data_dirs;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1__length1 = self->_data_dirs_length1;
#line 801 "Storage.c"
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection = _tmp1_;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection_length1 = _tmp1__length1;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		for (dir_it = 0; dir_it < _tmp1__length1; dir_it = dir_it + 1) {
#line 813 "Storage.c"
			GFile* _tmp2_;
			GFile* dir = NULL;
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			_tmp2_ = _g_object_ref0 (dir_collection[dir_it]);
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			dir = _tmp2_;
#line 820 "Storage.c"
			{
				GFile* _tmp3_;
				GFileType _tmp4_;
#line 45 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp3_ = dir;
#line 45 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp4_ = g_file_query_file_type (_tmp3_, 0, NULL);
#line 45 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				if (_tmp4_ == G_FILE_TYPE_DIRECTORY) {
#line 830 "Storage.c"
					GFile** _tmp5_;
					gint _tmp5__length1;
					GFile* _tmp6_;
					GFile* _tmp7_;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_tmp5_ = dirs;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_tmp5__length1 = dirs_length1;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_tmp6_ = dir;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
					_vala_array_add3 (&dirs, &dirs_length1, &_dirs_size_, _tmp7_);
#line 845 "Storage.c"
				}
#line 44 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (dir);
#line 849 "Storage.c"
			}
		}
	}
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp8_ = dirs;
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp8__length1 = dirs_length1;
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if (result_length1) {
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*result_length1 = _tmp8__length1;
#line 861 "Storage.c"
	}
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp8_;
#line 47 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 867 "Storage.c"
}


GFile* diorite_storage_get_user_cache_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_cache_dir;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp0_;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 882 "Storage.c"
}


void diorite_storage_set_user_cache_dir (DioriteStorage* self, GFile* value) {
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_if_fail (self != NULL);
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if (diorite_storage_get_user_cache_dir (self) != value) {
#line 891 "Storage.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp0_ = value;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_g_object_unref0 (self->priv->_user_cache_dir);
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		self->priv->_user_cache_dir = _tmp1_;
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_object_notify ((GObject *) self, "user-cache-dir");
#line 904 "Storage.c"
	}
}


GFile* diorite_storage_get_user_config_dir (DioriteStorage* self) {
	GFile* result;
	GFile* _tmp0_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = self->priv->_user_config_dir;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = _tmp0_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 920 "Storage.c"
}


void diorite_storage_set_user_config_dir (DioriteStorage* self, GFile* value) {
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_if_fail (self != NULL);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if (diorite_storage_get_user_config_dir (self) != value) {
#line 929 "Storage.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp0_ = value;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_g_object_unref0 (self->priv->_user_config_dir);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		self->priv->_user_config_dir = _tmp1_;
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_object_notify ((GObject *) self, "user-config-dir");
#line 942 "Storage.c"
	}
}


static void diorite_storage_class_init (DioriteStorageClass * klass) {
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_type_class_add_private (klass, sizeof (DioriteStoragePrivate));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_diorite_storage_get_property;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_diorite_storage_set_property;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	G_OBJECT_CLASS (klass)->finalize = diorite_storage_finalize;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_DATA_DIR, g_param_spec_object ("user-data-dir", "User data dir", "Directory used to store user-specific data. Read-write access may be available.", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_CACHE_DIR, g_param_spec_object ("user-cache-dir", "User cache dir", "Directory used to store user-specific cached data. Read-write access may be available.", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIORITE_STORAGE_USER_CONFIG_DIR, g_param_spec_object ("user-config-dir", "User configuration dir", "Directory used to store user-specific configuration data. Read-write access may be available.", g_file_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 964 "Storage.c"
}


static void diorite_storage_instance_init (DioriteStorage * self) {
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self->priv = DIORITE_STORAGE_GET_PRIVATE (self);
#line 971 "Storage.c"
}


static void diorite_storage_finalize (GObject * obj) {
	DioriteStorage * self;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIORITE_TYPE_STORAGE, DioriteStorage);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (self->priv->_user_data_dir);
#line 37 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self->_data_dirs = (_vala_array_free (self->_data_dirs, self->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 52 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (self->priv->_user_cache_dir);
#line 55 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (self->priv->_user_config_dir);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	G_OBJECT_CLASS (diorite_storage_parent_class)->finalize (obj);
#line 989 "Storage.c"
}


/**
 * File storage abstraction that provides easy access to a set of common paths: user's data,
 * cache and configuration directories and system data directories.
 */
GType diorite_storage_get_type (void) {
	static volatile gsize diorite_storage_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_storage_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteStorageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_storage_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteStorage), 0, (GInstanceInitFunc) diorite_storage_instance_init, NULL };
		GType diorite_storage_type_id;
		diorite_storage_type_id = g_type_register_static (G_TYPE_OBJECT, "DioriteStorage", &g_define_type_info, 0);
		g_once_init_leave (&diorite_storage_type_id__volatile, diorite_storage_type_id);
	}
	return diorite_storage_type_id__volatile;
}


static void _vala_diorite_storage_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DioriteStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_STORAGE, DioriteStorage);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_DATA_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_value_set_object (value, diorite_storage_get_user_data_dir (self));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_CACHE_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_value_set_object (value, diorite_storage_get_user_cache_dir (self));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_CONFIG_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		g_value_set_object (value, diorite_storage_get_user_config_dir (self));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 1032 "Storage.c"
		default:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 1038 "Storage.c"
	}
}


static void _vala_diorite_storage_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DioriteStorage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIORITE_TYPE_STORAGE, DioriteStorage);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	switch (property_id) {
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_DATA_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		diorite_storage_set_user_data_dir (self, g_value_get_object (value));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_CACHE_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		diorite_storage_set_user_cache_dir (self, g_value_get_object (value));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		case DIORITE_STORAGE_USER_CONFIG_DIR:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		diorite_storage_set_user_config_dir (self, g_value_get_object (value));
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 1066 "Storage.c"
		default:
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		break;
#line 1072 "Storage.c"
	}
}


/**
 * Creates new storage with XGD paths.
 */
DioriteXdgStorage* diorite_xdg_storage_construct (GType object_type) {
	DioriteXdgStorage * self = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 164 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 164 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
#line 164 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp3_ = g_get_user_config_dir ();
#line 164 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp4_ = g_get_user_cache_dir ();
#line 164 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self = (DioriteXdgStorage*) diorite_storage_construct (object_type, _tmp0_, _tmp2_, _vala_array_length (_tmp1_), _tmp3_, _tmp4_);
#line 161 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return self;
#line 1099 "Storage.c"
}


DioriteXdgStorage* diorite_xdg_storage_new (void) {
#line 161 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return diorite_xdg_storage_construct (DIORITE_TYPE_XDG_STORAGE);
#line 1106 "Storage.c"
}


/**
 * Creates new storage with XGD paths for a project.
 * 
 * @param id identifier of the project
 */
static void _vala_array_add4 (GFile** * array, int* length, int* size, GFile* value) {
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	if ((*length) == (*size)) {
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 1122 "Storage.c"
	}
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[(*length)++] = value;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	(*array)[*length] = NULL;
#line 1128 "Storage.c"
}


static GFile** _vala_array_dup4 (GFile** self, int length) {
	GFile** result;
	int i;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	result = g_new0 (GFile*, length + 1);
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	for (i = 0; i < length; i++) {
#line 1139 "Storage.c"
		GFile* _tmp0_;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		_tmp0_ = _g_object_ref0 (self[i]);
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		result[i] = _tmp0_;
#line 1145 "Storage.c"
	}
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return result;
#line 1149 "Storage.c"
}


DioriteXdgStorage* diorite_xdg_storage_construct_for_project (GType object_type, const gchar* id, const gchar* user_suffix) {
	DioriteXdgStorage * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile** data_dirs;
	GFile** _tmp24_;
	gint data_dirs_length1;
	gint _data_dirs_size_;
	GFile** _tmp25_;
	gint _tmp25__length1;
	GFile** _tmp31_;
	gint _tmp31__length1;
	GFile** _tmp32_;
	gint _tmp32__length1;
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	g_return_val_if_fail (user_suffix != NULL, NULL);
#line 175 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	self = (DioriteXdgStorage*) diorite_xdg_storage_construct (object_type);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp0_ = diorite_storage_get_user_data_dir ((DioriteStorage*) self);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp1_ = _tmp0_;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp2_ = id;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp3_ = user_suffix;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp5_ = _tmp4_;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp6_ = g_file_get_child (_tmp1_, _tmp5_);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp7_ = _tmp6_;
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_data_dir ((DioriteStorage*) self, _tmp7_);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp7_);
#line 176 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp5_);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp8_ = diorite_storage_get_user_config_dir ((DioriteStorage*) self);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp9_ = _tmp8_;
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp10_ = id;
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp11_ = user_suffix;
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp13_ = _tmp12_;
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp14_ = g_file_get_child (_tmp9_, _tmp13_);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp15_ = _tmp14_;
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_config_dir ((DioriteStorage*) self, _tmp15_);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp15_);
#line 177 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp13_);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp16_ = diorite_storage_get_user_cache_dir ((DioriteStorage*) self);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp17_ = _tmp16_;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp18_ = id;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp19_ = user_suffix;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp20_ = g_strconcat (_tmp18_, _tmp19_, NULL);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp21_ = _tmp20_;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp22_ = g_file_get_child (_tmp17_, _tmp21_);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp23_ = _tmp22_;
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_storage_set_user_cache_dir ((DioriteStorage*) self, _tmp23_);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_object_unref0 (_tmp23_);
#line 178 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_g_free0 (_tmp21_);
#line 180 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp24_ = g_new0 (GFile*, 0 + 1);
#line 180 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs = _tmp24_;
#line 180 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs_length1 = 0;
#line 180 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_data_dirs_size_ = data_dirs_length1;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp25_ = ((DioriteStorage*) self)->_data_dirs;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp25__length1 = ((DioriteStorage*) self)->_data_dirs_length1;
#line 1273 "Storage.c"
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection = _tmp25_;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		dir_collection_length1 = _tmp25__length1;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
		for (dir_it = 0; dir_it < _tmp25__length1; dir_it = dir_it + 1) {
#line 1285 "Storage.c"
			GFile* _tmp26_;
			GFile* dir = NULL;
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			_tmp26_ = _g_object_ref0 (dir_collection[dir_it]);
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
			dir = _tmp26_;
#line 1292 "Storage.c"
			{
				GFile** _tmp27_;
				gint _tmp27__length1;
				GFile* _tmp28_;
				const gchar* _tmp29_;
				GFile* _tmp30_;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp27_ = data_dirs;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp27__length1 = data_dirs_length1;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp28_ = dir;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp29_ = id;
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_tmp30_ = g_file_get_child (_tmp28_, _tmp29_);
#line 182 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_vala_array_add4 (&data_dirs, &data_dirs_length1, &_data_dirs_size_, _tmp30_);
#line 181 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
				_g_object_unref0 (dir);
#line 1313 "Storage.c"
			}
		}
	}
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp31_ = data_dirs;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp31__length1 = data_dirs_length1;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp32_ = (_tmp31_ != NULL) ? _vala_array_dup4 (_tmp31_, _tmp31__length1) : ((gpointer) _tmp31_);
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	_tmp32__length1 = _tmp31__length1;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	((DioriteStorage*) self)->_data_dirs = (_vala_array_free (((DioriteStorage*) self)->_data_dirs, ((DioriteStorage*) self)->_data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	((DioriteStorage*) self)->_data_dirs = _tmp32_;
#line 183 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	((DioriteStorage*) self)->_data_dirs_length1 = _tmp32__length1;
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	data_dirs = (_vala_array_free (data_dirs, data_dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return self;
#line 1335 "Storage.c"
}


DioriteXdgStorage* diorite_xdg_storage_new_for_project (const gchar* id, const gchar* user_suffix) {
#line 173 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	return diorite_xdg_storage_construct_for_project (DIORITE_TYPE_XDG_STORAGE, id, user_suffix);
#line 1342 "Storage.c"
}


static void diorite_xdg_storage_class_init (DioriteXdgStorageClass * klass) {
#line 156 "/builddir/build/BUILD/diorite-0.3.4/src/glib/Storage.vala"
	diorite_xdg_storage_parent_class = g_type_class_peek_parent (klass);
#line 1349 "Storage.c"
}


static void diorite_xdg_storage_instance_init (DioriteXdgStorage * self) {
}


/**
 * File storage abstraction that provides easy access to a set of common paths: user's data,
 * cache and configuration directories and system data directories. This implementation
 * uses paths compliant with XDG specification.
 */
GType diorite_xdg_storage_get_type (void) {
	static volatile gsize diorite_xdg_storage_type_id__volatile = 0;
	if (g_once_init_enter (&diorite_xdg_storage_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DioriteXdgStorageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) diorite_xdg_storage_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DioriteXdgStorage), 0, (GInstanceInitFunc) diorite_xdg_storage_instance_init, NULL };
		GType diorite_xdg_storage_type_id;
		diorite_xdg_storage_type_id = g_type_register_static (DIORITE_TYPE_STORAGE, "DioriteXdgStorage", &g_define_type_info, 0);
		g_once_init_leave (&diorite_xdg_storage_type_id__volatile, diorite_xdg_storage_type_id);
	}
	return diorite_xdg_storage_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1377 "Storage.c"
		int i;
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1385 "Storage.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	g_free (array);
#line 1397 "Storage.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	if (array) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
		while (((gpointer*) array)[length]) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
			length++;
#line 1410 "Storage.c"
		}
	}
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	return length;
#line 1415 "Storage.c"
}



