/* String.c generated by valac 0.36.2, the Vala compiler
 * generated from String.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))



gboolean diorite_string_is_empty (const gchar* str);
gchar* diorite_string_null_if_empty (const gchar* str);
GSList* diorite_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens);
GSList* diorite_string_array_to_slist (gchar** array, int array_length1, gboolean strip);
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
gint diorite_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gint diorite_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len);
gchar* diorite_string_unmask (guint8* data, int data_length1);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Check whether string is empty, i.e. `null` or `""`.
 * 
 * @param str    string to test
 * @return true if string is empty, false otherwise
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1086 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1087 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	return result;
#line 73 "String.c"
}


inline gboolean diorite_string_is_empty (const gchar* str) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp1_ = str;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp1_ == NULL) {
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp0_ = TRUE;
#line 87 "String.c"
	} else {
		const gchar* _tmp2_;
		gchar _tmp3_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp2_ = str;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp3_ = string_get (_tmp2_, (glong) 0);
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp0_ = _tmp3_ == '\0';
#line 97 "String.c"
	}
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 103 "String.c"
}


/**
 * Ensure string is not empty but either non-empty or null
 * 
 * @param str    original string
 * @return original string if it isn't empty, null otherwise	
 */
inline gchar* diorite_string_null_if_empty (const gchar* str) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* _tmp6_;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2_ = str;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp2_ == NULL) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp1_ = TRUE;
#line 125 "String.c"
	} else {
		const gchar* _tmp3_;
		gchar _tmp4_;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp3_ = str;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp4_ = string_get (_tmp3_, (glong) 0);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp1_ = _tmp4_ == '\0';
#line 135 "String.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp1_) {
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp0_ = NULL;
#line 141 "String.c"
	} else {
		const gchar* _tmp5_;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp5_ = str;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp0_ = _tmp5_;
#line 148 "String.c"
	}
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp6_;
#line 46 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 156 "String.c"
}


/**	
 * Splits a string into a maximum of `max_tokens` pieces, using the given `delimiter` and ignoring
 * empty elements after stripping.
 * 
 * If `max_tokens` is reached, the remainder of string is appended to the last token.
 * 
 * @param data          a string to split
 * @param delimiter     a string which specifies the places at which to split the string. The delimiter is not
 *                      included in any of the resulting strings, unless `max_tokens` is reached.
 * @param max_tokens    the maximum number of pieces to split string into. If this is less than 1, the string 
 *                      is split completely.
 * @return resulting list of strings
 */
GSList* diorite_string_split_strip (const gchar* data, const gchar* delimiter, gint max_tokens) {
	GSList* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	GSList* _tmp8_;
	GSList* _tmp9_;
#line 62 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	g_return_val_if_fail (delimiter != NULL, NULL);
#line 64 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0_ = data;
#line 64 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp1_ = diorite_string_is_empty (_tmp0_);
#line 64 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp1_) {
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		result = NULL;
#line 65 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		return result;
#line 198 "String.c"
	}
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2_ = data;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp3_ = delimiter;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp4_ = max_tokens;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp2_, _tmp3_, _tmp4_);
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp7_ = _tmp6_;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp7__length1 = _vala_array_length (_tmp5_);
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp8_ = diorite_string_array_to_slist (_tmp7_, _vala_array_length (_tmp5_), TRUE);
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp9_ = _tmp8_;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp9_;
#line 66 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 222 "String.c"
}


/**
 * Creates list from array of strings
 * 
 * @param array    string array
 * @param strip    strip array elements and ignore empty elements
 * @return resulting list of strings
 */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1207 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1208 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1208 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1209 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1209 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1210 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	result = _result_;
#line 1210 "/builddir/build/BUILD/diorite-0.3.4/vapi/glib-2.0.vapi"
	return result;
#line 252 "String.c"
}


static void _g_free0_ (gpointer var) {
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	var = (g_free (var), NULL);
#line 259 "String.c"
}


static void _g_slist_free__g_free0_ (GSList* self) {
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	g_slist_free (self);
#line 268 "String.c"
}


GSList* diorite_string_array_to_slist (gchar** array, int array_length1, gboolean strip) {
	GSList* result = NULL;
	GSList* _result_;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GSList* _tmp11_;
#line 79 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = NULL;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0_ = array;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0__length1 = array_length1;
#line 284 "String.c"
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		item_collection = _tmp0_;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		item_collection_length1 = _tmp0__length1;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		for (item_it = 0; item_it < _tmp0__length1; item_it = item_it + 1) {
#line 296 "String.c"
			const gchar* item = NULL;
#line 80 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
			item = item_collection[item_it];
#line 300 "String.c"
			{
				gboolean _tmp1_;
#line 82 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp1_ = strip;
#line 82 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				if (!_tmp1_) {
#line 307 "String.c"
					const gchar* _tmp2_;
					gchar* _tmp3_;
#line 84 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_tmp2_ = item;
#line 84 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_tmp3_ = g_strdup (_tmp2_);
#line 84 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_result_ = g_slist_prepend (_result_, _tmp3_);
#line 316 "String.c"
				} else {
					const gchar* _tmp4_;
					gboolean _tmp5_;
#line 86 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_tmp4_ = item;
#line 86 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_tmp5_ = diorite_string_is_empty (_tmp4_);
#line 86 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					if (!_tmp5_) {
#line 326 "String.c"
						gchar* stripped_item;
						const gchar* _tmp6_;
						gchar* _tmp7_;
						const gchar* _tmp8_;
						gboolean _tmp9_;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						_tmp6_ = item;
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						_tmp7_ = string_strip (_tmp6_);
#line 88 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						stripped_item = _tmp7_;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						_tmp8_ = stripped_item;
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						_tmp9_ = diorite_string_is_empty (_tmp8_);
#line 89 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						if (!_tmp9_) {
#line 344 "String.c"
							gchar* _tmp10_;
#line 90 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
							_tmp10_ = stripped_item;
#line 90 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
							stripped_item = NULL;
#line 90 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
							_result_ = g_slist_prepend (_result_, _tmp10_);
#line 352 "String.c"
						}
#line 86 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
						_g_free0 (stripped_item);
#line 356 "String.c"
					}
				}
			}
		}
	}
#line 93 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = g_slist_reverse (_result_);
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp11_ = _result_;
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = NULL;
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp11_;
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	__g_slist_free__g_free0_0 (_result_);
#line 94 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 374 "String.c"
}


gint diorite_string_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
#line 99 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0_ = str;
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp1_ = start_index;
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2_ = len;
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp3_ = c;
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp4_ = g_utf8_strchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
#line 101 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = _tmp4_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp6_ = _result_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp6_ != NULL) {
#line 406 "String.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp7_ = _result_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp8_ = str;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
#line 415 "String.c"
	} else {
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp5_ = -1;
#line 419 "String.c"
	}
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp5_;
#line 102 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 425 "String.c"
}


gint diorite_string_last_index_of_char (const gchar* str, gunichar c, gint start_index, gssize len) {
	gint result = 0;
	gchar* _result_;
	const gchar* _tmp0_;
	gint _tmp1_;
	gssize _tmp2_;
	gunichar _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_ = 0;
	gchar* _tmp6_;
#line 105 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0_ = str;
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp1_ = start_index;
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2_ = len;
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp3_ = c;
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp4_ = g_utf8_strrchr (((gchar*) _tmp0_) + _tmp1_, _tmp2_, _tmp3_);
#line 107 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = _tmp4_;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp6_ = _result_;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp6_ != NULL) {
#line 457 "String.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp7_ = _result_;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp8_ = str;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp5_ = (gint) (_tmp7_ - ((gchar*) _tmp8_));
#line 466 "String.c"
	} else {
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		_tmp5_ = -1;
#line 470 "String.c"
	}
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp5_;
#line 108 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 476 "String.c"
}


gchar* diorite_string_unmask (guint8* data, int data_length1) {
	gchar* result = NULL;
	gint length;
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_;
	guint8 shift;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8 _tmp3_;
	guint8* _result_;
	gint _tmp4_;
	guint8* _tmp5_;
	gint _result__length1;
	gint __result__size_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	gint _tmp22_;
	guint8 _tmp23_;
	guint8* _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
#line 113 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0_ = data;
#line 113 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp0__length1 = data_length1;
#line 113 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	length = _tmp0__length1;
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp1_ = length;
#line 114 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	if (_tmp1_ < 2) {
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		result = NULL;
#line 115 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		return result;
#line 516 "String.c"
	}
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2_ = data;
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp2__length1 = data_length1;
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp3_ = _tmp2_[0];
#line 116 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	shift = _tmp3_;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp4_ = length;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp5_ = g_new0 (guint8, _tmp4_);
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = _tmp5_;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result__length1 = _tmp4_;
#line 117 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	__result__size_ = _result__length1;
#line 536 "String.c"
	{
		gint i;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
		i = 1;
#line 541 "String.c"
		{
			gboolean _tmp6_;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
			_tmp6_ = TRUE;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
			while (TRUE) {
#line 548 "String.c"
				gint _tmp8_;
				gint _tmp9_;
				guint8 _tmp10_;
				guint8* _tmp11_;
				gint _tmp11__length1;
				gint _tmp12_;
				guint8 _tmp13_;
				guint8* _tmp14_;
				gint _tmp14__length1;
				gint _tmp15_;
				guint8* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				guint8 _tmp20_;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				if (!_tmp6_) {
#line 567 "String.c"
					gint _tmp7_;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_tmp7_ = i;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					i = _tmp7_ + 1;
#line 573 "String.c"
				}
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp6_ = FALSE;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp8_ = i;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp9_ = length;
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 118 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					break;
#line 585 "String.c"
				}
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp10_ = shift;
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp11_ = data;
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp11__length1 = data_length1;
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp12_ = i;
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp13_ = _tmp11_[_tmp12_];
#line 120 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				if (_tmp10_ > _tmp13_) {
#line 121 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					result = NULL;
#line 121 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					_result_ = (g_free (_result_), NULL);
#line 121 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
					return result;
#line 605 "String.c"
				}
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp14_ = _result_;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp14__length1 = _result__length1;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp15_ = i;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp16_ = data;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp16__length1 = data_length1;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp17_ = i;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp18_ = _tmp16_[_tmp17_];
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp19_ = shift;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp14_[_tmp15_ - 1] = _tmp18_ - _tmp19_;
#line 122 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
				_tmp20_ = _tmp14_[_tmp15_ - 1];
#line 627 "String.c"
			}
		}
	}
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp21_ = _result_;
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp21__length1 = _result__length1;
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp22_ = length;
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp21_[_tmp22_] = (guint8) 0;
#line 124 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp23_ = _tmp21_[_tmp22_];
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp24_ = _result_;
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp24__length1 = _result__length1;
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_tmp25_ = g_strdup ((const gchar*) _tmp24_);
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	result = _tmp25_;
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	_result_ = (g_free (_result_), NULL);
#line 125 "/builddir/build/BUILD/diorite-0.3.4/src/glib/String.vala"
	return result;
#line 653 "String.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 660 "String.c"
		int i;
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
				destroy_func (((gpointer*) array)[i]);
#line 668 "String.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	g_free (array);
#line 680 "String.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	if (array) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
		while (((gpointer*) array)[length]) {
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
			length++;
#line 693 "String.c"
		}
	}
#line 63 "/builddir/build/BUILD/diorite-0.3.4/src/glib/BaseBus.vala"
	return length;
#line 698 "String.c"
}



